unit CorbaDBClientFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, ExtCtrls, Grids, DBGrids, CorbaCon, StdCtrls, ActnList;

type
  TForm2 = class(TForm)
    DBGrid1: TDBGrid;
    CDS: TClientDataSet;
    DataSource1: TDataSource;
    CorbaConnection1: TCorbaConnection;
    btnConnect: TButton;
    btnDisconnect: TButton;
    btnApply: TButton;
    ActionList1: TActionList;
    ApplyUpdates: TAction;
    ConnectToServer: TAction;
    DisconnectFromServer: TAction;
    procedure FormCreate(Sender: TObject);
    procedure ConnectToServerExecute(Sender: TObject);
    procedure ConnectToServerUpdate(Sender: TObject);
    procedure ApplyUpdatesExecute(Sender: TObject);
    procedure ApplyUpdatesUpdate(Sender: TObject);
    procedure DisconnectFromServerExecute(Sender: TObject);
    procedure DisconnectFromServerUpdate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  Registry, CorbaObj;

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
const
  Path = 'Software\Microsoft\Windows\CurrentVersion\Internet Settings';
  EnableAutoDial = 'EnableAutoDial';
  DisableIt: Longint = 0;
var
  EnableIt: Longint;
  ChangeIt: Boolean;
begin
  //We're gonna play with the registry
  with TRegistry.Create() do
  try
    //Flag for later on
    ChangeIt := False;
    //Do we have these Internet settings?
    if OpenKey(Path, False) then
    begin
      //Check the AutoConnect option
      ReadBinaryData(EnableAutoDial, EnableIt, Sizeof(EnableIt));
      //If it is on, we will turn it off
      ChangeIt := EnableIt <> DisableIt;
      if ChangeIt then
        WriteBinaryData(EnableAutoDial, DisableIt, Sizeof(DisableIt));
    end;
    //We call this now to prevent a minor delay later on
    //when CORBA stuff actually happens, but primarily so we
    //can pevent the Dial-Up Networking box if necessary
    CorbaInitialize;
    //If we changed something, put it back to how it was
    if ChangeIt then
      WriteBinaryData(EnableAutoDial, EnableIt, Sizeof(EnableIt))
  finally
    Free
  end
end;

procedure TForm2.ConnectToServerExecute(Sender: TObject);
var
  OldTime: TDateTime;
  H, M, S, MS: Word;
begin
  Caption := '';
  OldTime := Now;
//  CorbaConnection1.Connected := True;
  CDS.Active := True;
  DecodeTime(Now - OldTime, H, M, S, MS);
  Caption := Format('%d mins, %d secs', [M, S]);
end;

procedure TForm2.ConnectToServerUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := not CorbaConnection1.Connected
end;

procedure TForm2.ApplyUpdatesExecute(Sender: TObject);
begin
  CDS.ApplyUpdates(-1)
end;

procedure TForm2.ApplyUpdatesUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := CDS.ChangeCount > 0
end;

procedure TForm2.DisconnectFromServerExecute(Sender: TObject);
begin
  CorbaConnection1.Connected := False;
  CDS.Active := False;
end;

procedure TForm2.DisconnectFromServerUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := CorbaConnection1.Connected
end;

end.
